<?php

/***************************************************
  Cartproductfeed - Feed Model
	  Copyright 2014 Purple Turtle Productions. All rights reserved.
		license	GNU General Public License version 3 or later; see GPLv3.txt
    2014-06-16 by Keneto
			2014-09 Moved to Joomla3
 ***************************************************/

defined('_JEXEC') or die;

class CartproductfeedModelFeed extends JModelAdmin {

	public function getTable($type = 'Feed', $prefix = 'CartproductfeedTable', $config = array()) {
		return JTable::getInstance($type, $prefix, $config);
	}

	public function getForm($data = array(), $loadData = true) {

		// Get the form.
		$form = $this->loadForm('com_cartproductfeed.feed', 'feed', array('control' => 'jform', 'load_data' => $loadData));

		if (empty($form))
			return false;

		// Modify the form based on access controls.
		if (!$this->canEditState((object) $data)) {
			// Disable fields for display.
			$form->setFieldAttribute('ordering', 'disabled', 'true');
			$form->setFieldAttribute('state', 'disabled', 'true');
			$form->setFieldAttribute('publish_up', 'disabled', 'true');
			$form->setFieldAttribute('publish_down', 'disabled', 'true');

			// Disable fields while saving.
			// The controller has already verified this is a record you can edit.
			$form->setFieldAttribute('ordering', 'filter', 'unset');
			$form->setFieldAttribute('state', 'filter', 'unset');
			$form->setFieldAttribute('publish_up', 'filter', 'unset');
			$form->setFieldAttribute('publish_down', 'filter', 'unset');
		}

		return $form;

	}

	//Method to get the data that should be injected in the form.
	protected function loadFormData() {

		// Check the session for previously entered form data.
		$data = JFactory::getApplication()->getUserState('com_cartproductfeed.edit.feed.data', array());

		if (empty($data)) {
			$data = $this->getItem();

			// Prime some default values.
			if ($this->getState('feed.id') == 0) {
				$app = JFactory::getApplication();
				$data->set('catid', $app->input->get('catid', $app->getUserState('com_cartproductfeed.feed.filter.category_id'), 'int'));
			}
		}

		$this->preprocessData('com_cartproductfeed.feed', $data);

		return $data;

	}

	//Prepare and sanitise the table data prior to saving.
	//@param   JTable  $table  A reference to a JTable object.
	protected function prepareTable($table) {

		$date = JFactory::getDate();
		$user = JFactory::getUser();

		$table->description = htmlspecialchars_decode($table->description, ENT_QUOTES);

		if (empty($table->id) && empty($table->ordering)) {
			$db = JFactory::getDbo();
			$db->setQuery('SELECT MAX(ordering) FROM #__cartproductfeed_feeds');
			$max = $db->loadResult();

			$table->ordering = $max + 1;
		}

		$table->modified    = $date->toSql();
		$table->modified_by = $user->get('id');	

	}

	//A protected method to get a set of ordering conditions.
	protected function getReorderConditions($table) {
		$condition = array();
		$condition[] = 'catid = ' . (int) $table->catid;

		return $condition;
	}

	//Method to save the form data.
	public function save($data) {

		$date = JFactory::getDate();
		$user = JFactory::getUser();

		if (empty($data['modified']))
			$data['modified'] = $date->toSql();

		if (empty($data['modified_by']))
			$data['modified_by'] = $user->get('id');

		//$input = JFactory::getApplication()->input;
		//$data['caseworker_id'] = $input->getInt('edtCaseWorker', 0);
		//$data['family_id'] = $input->getInt('edtFamily', 0);

		return parent::save($data);

  }

}
