<?php

/***************************************************
  Cartproductfeed - Feed View
	  Copyright 2014 Purple Turtle Productions. All rights reserved.
		license	GNU General Public License version 3 or later; see GPLv3.txt
    2014-06-16 by Keneto
			2014-09 Moved to Joomla3
 ***************************************************/

defined('_JEXEC') or die;

//Import the core
require_once dirname(__FILE__) . '/../../core/data/feedcore.php';
require_once dirname(__FILE__) . '/../../core/classes/cart-product-feed.php';
require_once dirname(__FILE__) . '/../../core/classes/dialogeditfeed.php';
//require_once dirname(__FILE__) . '/../../core/classes/dialogfeedpage.php';
require_once dirname(__FILE__) . '/../../core/classes/dialoglicensekey.php';
require_once dirname(__FILE__) . '/../../core/registration.php';

class CartproductfeedViewFeed extends JViewLegacy {

	protected $state;

	protected $item;

	protected $form;

	//Display the view
	public function display($tpl = null) {
	
		$document = JFactory::getDocument();
		$document->addStyleSheet(JURI::root(true) . '/administrator/components/com_cartproductfeed/css/cart-product.css');
		$document->addStyleSheet(JURI::root(true) . '/administrator/components/com_cartproductfeed/css/colorbox.css');
		$document->addScript(JURI::root(true) . '/media/jui/js/jquery.min.js');
		$document->addScript(JURI::root(true) . '/administrator/components/com_cartproductfeed/js/cart-product.js');
		$document->addScript(JURI::root(true) . '/administrator/components/com_cartproductfeed/js/jquery.colorbox.js');

		$this->state	= $this->get('State');
		$this->item		= $this->get('Item');
		$this->form		= $this->get('Form');

		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}

		global $pfcore;

		if ($pfcore->callSuffix == 'JS') {
			$db = JFactory::getDBO();
			$db->setQuery('SELECT shop_id FROM #__cartproductfeed_feeds WHERE id=' . $this->item->id);
			$pfcore->shopID = $db->loadResult();
		}

		$this->addToolbar();
		parent::display($tpl);

	}

	//Add the page title and toolbar.
	protected function addToolbar() {

		JFactory::getApplication()->input->set('hidemainmenu', true);

		$user		= JFactory::getUser();
		$isNew		= ($this->item->id == 0);
		$checkedOut	= !($this->item->checked_out == 0 || $this->item->checked_out == $user->get('id'));

		JToolbarHelper::title('Cart Product Feed', '');

		if (!$checkedOut && ($user->authorise('core.create', 'com_cartproductfeed') || $user->authorise('core.edit', 'com_cartproductfeed')) ) {
			JToolbarHelper::apply('feed.apply');
			JToolbarHelper::save('feed.save');
		}
		if (!$checkedOut && (count($user->getAuthorisedCategories('com_cartproductfeed', 'core.create'))))
			JToolbarHelper::save2new('feed.save2new');

		// If an existing item, can save to a copy.
		if (!$isNew && $user->authorise('core.create', 'com_cartproductfeed'))
			JToolbarHelper::save2copy('feed.save2copy');

		if (empty($this->item->id))
			JToolbarHelper::cancel('feed.cancel');
		else {
			if ($this->state->params->get('save_history', 0) && $user->authorise('core.edit'))
				JToolbarHelper::versions('com_cartproductfeed.feed', $this->item->id);
			JToolbarHelper::cancel('feed.cancel', 'JTOOLBAR_CLOSE');
		}

	}

}
