<?php

	/***************************************************
	Cartproductfeed - Feeds View
	Copyright 2014 Purple Turtle Productions. All rights reserved.
	license	GNU General Public License version 3 or later; see GPLv3.txt
		2014-06-16 by Keneto
	***************************************************/
 
// No direct access to this file
defined('_JEXEC') or die('Restricted access');
 
// import Joomla view library
//jimport('joomla.application.component.view');

require_once dirname(__FILE__) . '/../../core/data/feedcore.php';
require_once dirname(__FILE__) . '/../../core/data/feedfolders.php';
 
class CartproductfeedViewFeeds extends JViewLegacy {

	protected $items;

	protected $pagination;

	protected $state;

	// Overwriting JView display method
	function display($tpl = null) {

		global $pfcore;

		$document = JFactory::getDocument();
		$document->addStyleSheet(JURI::root(true) . '/administrator/components/com_cartproductfeed/css/cart-product.css');
		$document->addStyleSheet(JURI::root(true) . '/administrator/components/com_cartproductfeed/css/colorbox.css');
		$document->addScript(JURI::root(true) . '/media/jui/js/jquery.min.js');
		$document->addScript(JURI::root(true) . '/administrator/components/com_cartproductfeed/js/cart-product.js');
		$document->addScript(JURI::root(true) . '/administrator/components/com_cartproductfeed/js/jquery.colorbox.js');
  
		$this->state		= $this->get('State');
		$this->items		= $this->get('Items');
		$this->pagination	= $this->get('Pagination');

		// Assign data to the view
		$this->msg = $this->get('Msg');

		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JLog::add(implode('<br />', $errors), JLog::WARNING, 'jerror');
			return false;
		}

		require_once JPATH_COMPONENT . '/helpers/cartproductfeed.php';
		CartproductfeedHelper::addSubmenu('feeds');

		if ($pfcore->callSuffix == 'JH') {
			$this->msg = '';
			$this->token = $pfcore->settingGet('cp_rapidcarttoken');
			$tpl = 'rapidcart';
		} else
			$this->addToolbar();

		$this->sidebar = JHtmlSidebar::render();

		parent::display($tpl);

	}
  
  protected function addToolbar() {

		require_once JPATH_COMPONENT . '/helpers/cartproductfeed.php';

		$state	= $this->get('State');
		$user	= JFactory::getUser();

		// Get the toolbar object instance
		$bar = JToolBar::getInstance('toolbar');

		JToolBarHelper::title('<a href="./index.php?option=com_cartproductfeed">Feeds</a> <span class="version-style-j">Version: ' . FEED_PLUGIN_VERSION .'</span>', 'cpficon');
		$document = JFactory::getDocument();
		$document->setTitle(JFactory::getApplication()->getCfg('sitename') . ' - Cart Product Feed');

		if ($user->authorise('core.admin', 'com_cartproductfeed'))
			JToolbarHelper::addNew('feed.add');

		if ($user->authorise('core.edit', 'com_cartproductfeed')) {

			JToolbarHelper::editList('feed.edit');
			JToolbarHelper::publish('feeds.publish', 'JTOOLBAR_PUBLISH', true);
			JToolbarHelper::unpublish('feeds.unpublish', 'JTOOLBAR_UNPUBLISH', true);

			JToolbarHelper::archiveList('feeds.archive');
			JToolbarHelper::checkin('feeds.checkin');

			if ($state->get('filter.state') == -2)
				JToolbarHelper::deleteList('', 'feeds.delete', 'JTOOLBAR_EMPTY_TRASH');
			else
				JToolbarHelper::trash('feeds.trash');
		}

		JHtmlSidebar::setAction('index.php?option=com_cartproductfeed&view=feeds');

		JHtmlSidebar::addFilter(
			JText::_('JOPTION_SELECT_PUBLISHED'),
			'filter_state',
			JHtml::_('select.options', JHtml::_('jgrid.publishedOptions'), 'value', 'text', $this->state->get('filter.state'), true)
		);

		JHtmlSidebar::addFilter(
			JText::_('JOPTION_SELECT_CATEGORY'),
			'filter_category_id',
			JHtml::_('select.options', JHtml::_('category.options', 'com_weblinks'), 'value', 'text', $this->state->get('filter.category_id'))
		);

		JHtmlSidebar::addFilter(
			JText::_('JOPTION_SELECT_ACCESS'),
			'filter_access',
			JHtml::_('select.options', JHtml::_('access.assetgroups'), 'value', 'text', $this->state->get('filter.access'))
		);

		JHtmlSidebar::addFilter(
			JText::_('JOPTION_SELECT_LANGUAGE'),
			'filter_language',
			JHtml::_('select.options', JHtml::_('contentlanguage.existing', true, true), 'value', 'text', $this->state->get('filter.language'))
		);

		JHtmlSidebar::addFilter(
		JText::_('JOPTION_SELECT_TAG'),
		'filter_tag',
		JHtml::_('select.options', JHtml::_('tag.options', true, true), 'value', 'text', $this->state->get('filter.tag'))
		);

	}
  
	protected function getSortFields()
	{
		return array(
			'a.title' => JText::_('JGLOBAL_TITLE'),
			'c.title' => 'Category',
			'a.ordering' => 'Sort Order',
			'a.created_by' => 'Creator',
			'a.date' => 'Creation Date',
			'a.id' => JText::_('JGRID_HEADING_ID')
		);
	}  
  
}

?>